//**********************************************************************************
//                                                                                  
//        _   _       _        ___  ___      _        ___  ___          _             
//       | | | |     | |       |  \/  |     | |       |  \/  |         | |            
//       | |_| | ___ | |_   _  | .  . | ___ | |_   _  | .  . | ___   __| |___       
//       |  _  |/ _ \| | | | | | |\/| |/ _ \| | | | | | |\/| |/ _ \ / _` / __|      
//       | | | | (_) | | |_| | | |  | | (_) | | |_| | | |  | | (_) | (_| \__ \      
//       \_| |_/\___/|_|\__, | \_|  |_/\___/|_|\__, | \_|  |_/\___/ \__,_|___/      
//                       __/ |                  __/ |                               
//                      |___/                  |___/                                
//                                                                                  
//                       Website: http://www.holymolymods.com                       
//*********************************************************************************
// Coded for Openwarfare Mod by [105]HolyMoly  Oct 5/2014
// V.4.0 Final

#include openwarfare\_eventmanager;
#include openwarfare\_utils;
#include maps\mp\gametypes\_hud_util;
#include maps\mp\_utility;
#include common_scripts\utility;

init()
{

	// Get the main module's dvars
	level.scr_field_orders = getdvarx( "scr_field_orders", "int", 4, 0, 5 ); // 1 = perks, 2 = points, 3 = hardpoints, 4 = perks and hardpoints, 5 = perks, points and hardpoints  

        // If not activated or certain gametypes
	if ( level.scr_field_orders == 0 || 
                level.gameType == "aon" || 
                level.gameType == "bel" || 
                level.gameType == "ftag" || 
                level.gameType == "gg" ||
                level.gameType == "hns" ||
                level.gameType == "oitc" || 
                level.gameType == "ss" ||
                level.gameType == "toitc" || 
                level.gameType == "vg" ) {  

                level.fieldOrders = false;
		return;
        }

        level.fieldOrders = true;

        // Dvars
        level.scr_field_order_reminder_time = getdvarx( "scr_field_order_reminder_time", "int", 15, 5, 300 );
        level.scr_field_order_headshot_only = getdvarx( "scr_field_order_headshot_only", "int", 0, 0, 1 );
        level.scr_field_order_timer = getdvarx( "scr_field_order_timer", "int", 30, 0, 300 );
        level.scr_field_order_timer_reset = getdvarx( "scr_field_order_timer_reset", "int", 45, 5, 600 );
        level.scr_field_order_explosion_fx = getdvarx( "scr_field_order_explosion_fx", "int", 1, 0, 1 );

        //Field Order Counters
        level.scr_field_order_0 = getdvarx( "scr_field_order_0", "int", 2, 1, 10 );
        level.scr_field_order_1 = getdvarx( "scr_field_order_1", "int", 2, 1, 10 );
        level.scr_field_order_2 = getdvarx( "scr_field_order_2", "int", 3, 1, 10 );
        level.scr_field_order_3 = getdvarx( "scr_field_order_3", "int", 2, 1, 10 );
        level.scr_field_order_4 = getdvarx( "scr_field_order_4", "int", 1, 1, 10 );
        level.scr_field_order_5 = getdvarx( "scr_field_order_5", "int", 3, 1, 10 );
        level.scr_field_order_6 = getdvarx( "scr_field_order_6", "int", 2, 1, 10 );
        level.scr_field_order_7 = getdvarx( "scr_field_order_7", "int", 3, 1, 10 );
        level.scr_field_order_8 = getdvarx( "scr_field_order_8", "int", 2, 1, 10 );
        level.scr_field_order_9 = getdvarx( "scr_field_order_9", "int", 2, 1, 10 );
        level.scr_field_order_10 = getdvarx( "scr_field_order_10", "int", 2, 1, 10 );

        if( level.scr_field_orders == 1 ) {

                // Field order Perks
                level.scr_field_order_perks = getdvarx( "scr_field_order_perks", "int", 0, 0, 12 );
                level.scr_field_order_extra_health = getdvarx( "scr_field_order_extra_health", "int", 2, 0, 5 );
	        level.scr_field_order_special_weapon = getdvarx( "scr_field_order_special_weapon", "string", "brick_blaster_mp" );
	        if ( !issubstr( "brick_blaster_mp;beretta_mp;colt45_mp;usp_mp;deserteagle_mp;deserteaglegold_mp;m1014_mp;mp44_mp;p90_mp;rpd_mp;barrett_mp", level.scr_field_order_special_weapon ) ) {
		        level.scr_field_order_special_weapon = "brick_blaster_mp";
                }
                level.scr_field_order_move_speed = getdvarx( "scr_field_order_move_speed", "float", 1.25, 1, 1.5 );
                level.scr_field_order_uav_time = getdvarx( "scr_field_order_uav_time", "int", 15, 0, 180 );

        }


        if( level.scr_field_orders == 2 ) {

                //Field Order Points
                level.scr_field_order_0_points = getdvarx( "scr_field_order_0_points", "int", 20, 0, 1000 );
                level.scr_field_order_1_points = getdvarx( "scr_field_order_1_points", "int", 20, 0, 1000 );
                level.scr_field_order_2_points = getdvarx( "scr_field_order_2_points", "int", 30, 0, 1000 );
                level.scr_field_order_3_points = getdvarx( "scr_field_order_3_points", "int", 20, 0, 1000);
                level.scr_field_order_4_points = getdvarx( "scr_field_order_4_points", "int", 10, 0, 1000 );
                level.scr_field_order_5_points = getdvarx( "scr_field_order_5_points", "int", 30, 0, 1000 );
                level.scr_field_order_6_points = getdvarx( "scr_field_order_6_points", "int", 20, 0, 1000 );
                level.scr_field_order_7_points = getdvarx( "scr_field_order_7_points", "int", 30, 0, 1000 );
                level.scr_field_order_8_points = getdvarx( "scr_field_order_8_points", "int", 20, 0, 1000 );
                level.scr_field_order_9_points = getdvarx( "scr_field_order_9_points", "int", 20, 0, 1000 );
                level.scr_field_order_10_points = getdvarx( "scr_field_order_10_points", "int", 20, 0, 1000 );
                level.scr_field_order_11_points = getdvarx( "scr_field_order_11_points", "int", 10, 0, 1000 );
        }

        if( level.scr_field_orders == 3 ) {

                // Field order Hardpoints
                level.scr_field_order_hardpoint_type = getdvarx( "scr_field_order_hardpoint_type", "int", 0, 0, 3 );
                level.scr_field_order_kill_streak_reset = getdvarx( "scr_field_order_kill_streak_reset", "int", 0, 0, 1 );

        }

        if( level.scr_field_orders == 4 ) {

                // Field order Perks
                level.scr_field_order_perks = getdvarx( "scr_field_order_perks", "int", 0, 0, 12 );
                level.scr_field_order_extra_health = getdvarx( "scr_field_order_extra_health", "int", 2, 0, 5 );
	        level.scr_field_order_special_weapon = getdvarx( "scr_field_order_special_weapon", "string", "brick_blaster_mp" );
	        if ( !issubstr( "brick_blaster_mp;beretta_mp;colt45_mp;usp_mp;deserteagle_mp;deserteaglegold_mp;m1014_mp;mp44_mp;p90_mp;rpd_mp;barrett_mp", level.scr_field_order_special_weapon ) ) {
		        level.scr_field_order_special_weapon = "brick_blaster_mp";
                }
                level.scr_field_order_move_speed = getdvarx( "scr_field_order_move_speed", "float", 1.25, 1, 1.5 );
                level.scr_field_order_uav_time = getdvarx( "scr_field_order_uav_time", "int", 15, 0, 180 );

                // Field order hardpoints
                level.scr_field_order_hardpoint_type = getdvarx( "scr_field_order_hardpoint_type", "int", 0, 0, 3 );
                level.scr_field_order_kill_streak_reset = getdvarx( "scr_field_order_kill_streak_reset", "int", 0, 0, 1 );

        }

        if( level.scr_field_orders == 5 ) {

                // Field order Perks
                level.scr_field_order_perks = getdvarx( "scr_field_order_perks", "int", 0, 0, 12 );
                level.scr_field_order_extra_health = getdvarx( "scr_field_order_extra_health", "int", 2, 0, 5 );
	        level.scr_field_order_special_weapon = getdvarx( "scr_field_order_special_weapon", "string", "brick_blaster_mp" );
	        if ( !issubstr( "brick_blaster_mp;beretta_mp;colt45_mp;usp_mp;deserteagle_mp;deserteaglegold_mp;m1014_mp;mp44_mp;p90_mp;rpd_mp;barrett_mp", level.scr_field_order_special_weapon ) ) {
		        level.scr_field_order_special_weapon = "brick_blaster_mp";
                }
                level.scr_field_order_move_speed = getdvarx( "scr_field_order_move_speed", "float", 1.25, 1, 1.5 );
                level.scr_field_order_uav_time = getdvarx( "scr_field_order_uav_time", "int", 15, 0, 180 );

                //Field Order Points
                level.scr_field_order_0_points = getdvarx( "scr_field_order_0_points", "int", 20, 0, 1000 );
                level.scr_field_order_1_points = getdvarx( "scr_field_order_1_points", "int", 20, 0, 1000 );
                level.scr_field_order_2_points = getdvarx( "scr_field_order_2_points", "int", 30, 0, 1000 );
                level.scr_field_order_3_points = getdvarx( "scr_field_order_3_points", "int", 20, 0, 1000);
                level.scr_field_order_4_points = getdvarx( "scr_field_order_4_points", "int", 10, 0, 1000 );
                level.scr_field_order_5_points = getdvarx( "scr_field_order_5_points", "int", 30, 0, 1000 );
                level.scr_field_order_6_points = getdvarx( "scr_field_order_6_points", "int", 20, 0, 1000 );
                level.scr_field_order_7_points = getdvarx( "scr_field_order_7_points", "int", 30, 0, 1000 );
                level.scr_field_order_8_points = getdvarx( "scr_field_order_8_points", "int", 20, 0, 1000 );
                level.scr_field_order_9_points = getdvarx( "scr_field_order_9_points", "int", 20, 0, 1000 );
                level.scr_field_order_10_points = getdvarx( "scr_field_order_10_points", "int", 20, 0, 1000 );
                level.scr_field_order_11_points = getdvarx( "scr_field_order_11_points", "int", 10, 0, 1000 );

                // Field order hardpoints
                level.scr_field_order_hardpoint_type = getdvarx( "scr_field_order_hardpoint_type", "int", 0, 0, 3 );
                level.scr_field_order_kill_streak_reset = getdvarx( "scr_field_order_kill_streak_reset", "int", 0, 0, 1 );

        }

	// Precache other assets
	game[level.gameType]["fieldOrderModel"] = "hm_bluecase";
	precacheModel( game[level.gameType]["fieldOrderModel"] );

        game[level.gameType]["blue_fx"] = loadfx( "impacts/fieldOrder_explode_blue" );

        precacheShader( "blue_briefcase" );
        precacheShader( "waypoint_field_order" );
        precacheShader( "compass_field_order" );

        precacheStatusIcon( "blue_briefcase" );

        // Special Weapon
        precacheItem( "brick_blaster_mp" );

	level thread addNewEvent( "onPlayerConnected", ::onPlayerConnected );

}

onPlayerConnected()
{

	self thread addNewEvent( "onPlayerSpawned", ::onPlayerSpawned );
        self thread addNewEvent( "onJoinedSpectators", ::onJoinedSpectators );
        self thread onPlayerDisconnect();
        
}

onPlayerSpawned()
{

        // Clear all fields
        self.hasFieldOrders = false;
        self.fieldOrdersComplete = false;
        self.orderNumber = -1;
        self.points = 0;
        self.perkPick = undefined;
        self.pickPerk = undefined;
        self.crouchKill = 0;
        self.proneKill = 0;
        self.headshotKill = 0;
        self.meleeKill = 0;
        self.jumpKill = 0;
        self.behindKill = 0;
        self.sniperKill = 0;
        self.pistolKill = 0;
        self.explosiveKill = 0;
        self.hardpointKill = 0;
        self.pickedWeaponKill = 0;
        self.statusicon = "";
        self.hasSpecialWeapon = false;
        self.hasFasterSpeed = false;
        self.flashProtected = false;
        self.concussionProtected = false;
        self.claymoreProtected = false;
        self.c4Protected = false;
        self.fragProtected = false;
        self.hardpointProtected = false;

        // Turn off compass if killed before timer is up!
        if( level.scr_game_forceuav == 0 ) 
                self setClientDvar( "g_compassshowenemies", "0" );

        // Briefcase icon
        if( !isDefined( self.caseIcon ) && !level.hardcoreMode ) {
	        self.caseIcon = createIcon( "blue_briefcase", 28, 28 );
		self.caseIcon setPoint( "CENTER", "CENTER", 250, 204 ); // 220, 140
		self.caseIcon.alpha = 0;
        }
        
        self thread checkFieldOrders();
        
}

onJoinedSpectators()
{

        if( isDefined( self.hasFieldOrders ) && self.hasFieldOrders == true ) {
                self.hasFieldOrders = false;
                level.fieldOrdersActive = false;

                if( isDefined( self.caseIcon ) )
                        self.caseIcon.alpha = 0;        
        }

}

onPlayerDisconnect()
{

        self waittill( "disconnect" );

        if( isDefined( self.hasFieldOrders ) && self.hasFieldOrders == true ) {
                self.hasFieldOrders = false;
                level.fieldOrdersActive = false;

                if( isDefined( self.caseIcon ) )
                        self.caseIcon.alpha = 0;
        }

}

removeTriggerOnPickup( fieldOrderTrigger, fieldOrder )
{ 
        fieldOrderTrigger endon( "timer_reset" );

        fieldOrderTrigger waittill( "trigger", player );

        // If by some chance a dead player activates the trigger, the suitcase will simply be deleted and field orders restarted!
        if ( isAlive( player ) ) {

                // Cannot pickup if Spawn Protected
                if( isDefined( player.spawn_protected ) && player.spawn_protected == true ) {
                        fieldOrder thread removeTriggerOnPickup( fieldOrderTrigger, fieldOrder );
                        return;
                }

                player.hasFieldOrders = true;

                // Briefcase Icon On
		if ( isDefined( player.caseIcon ) )
                        player.caseIcon.alpha = 0.6;

                player.statusicon = "blue_briefcase";

                player.orderNumber = randomInt( 12 );

                // Field Order Notification
	        notifyData = spawnStruct();
	        notifyData.titleText = "Field Orders Received";

                if( player.orderNumber == 0 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_0 + " kills while Crouched" );
                if( player.orderNumber == 1 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_1 + " kills while Prone" );
                if( player.orderNumber == 2 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_2 + " kills with a Headshot" );
                if( player.orderNumber == 3 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_3 + " kills with a Knife" );
                if( player.orderNumber == 4 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_4 + " kills while Jumping" );
                if( player.orderNumber == 5 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_5 + " kills from Behind" );
                if( player.orderNumber == 6 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_6 + " kills with a Sniper Rifle" );
                if( player.orderNumber == 7 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_7 + " kills with a Pistol" );
                if( player.orderNumber == 8 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_8 + " kills with an Explosive Weapon" );
                if( player.orderNumber == 9 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_9 + " kills with a Hardpoint Weapon" );
                if( player.orderNumber == 10 ) notifyData.notifyText = ( "Earn " + level.scr_field_order_10 + " kills with a Picked Up Weapon" );
                if( player.orderNumber == 11 ) notifyData.notifyText = "Humiliate the next enemy you kill";

	        notifyData.iconName = "blue_briefcase";
                notifyData.glowColor = ( 0, 0.9, 1 ); // light blue
	        notifyData.duration = 5.0;

                player thread maps\mp\gametypes\_hud_message::notifyMessage( notifyData );

                if( level.scr_field_order_reminder_time > 0 )
                        player thread showReminder( notifyData.notifyText );

                player playLocalSound( "case_pickup" );

        } else {

                player.hasFieldOrders = false;
                level.fieldOrdersActive = false;

        }


        // Notify trigger and model picked up
        fieldOrder notify( "picked_up" );

        wait( 0.08 );

        // Delete Trigger and Model
        fieldOrderTrigger delete();
	fieldOrder delete();

}

checkFieldOrders()
{

	self endon( "check_complete" );
	self endon( "disconnect" );
	level endon("game_ended");

	// Wait for the player to die
	self waittill( "player_killed", eInflictor, attacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, psOffsetTime, deathAnimDuration, fDistance );

        // Briecase icon off
        if( isDefined( self.caseIcon ) ) {
                self.caseIcon.alpha = 0;
        }

        // Reset
        if( level.scr_game_forceuav == 0 ) 
                self setClientDvar( "g_compassshowenemies", "0" );

        // First time and reset, if killed by suicide, or non player...... restart orders!
        if( level.fieldOrdersActive == false && isPlayer( attacker ) && attacker != self ) {

                // Team or FFA gametype setting
                if( level.teamBased ) {
                        if( attacker.pers["team"] == self.pers["team"] )
                                return;
                }

                // Headshot Only Dvar
                if( level.scr_field_order_headshot_only == 1 && !isHeadShot( sWeapon, sHitLoc, sMeansOfDeath ) ) {
                        return;
                }

                level.fieldOrdersActive = true;
                
                // Place spawnpoint on the ground based on player box size 
                basePosition = playerPhysicsTrace( self.origin, self.origin + ( 0, 0, -99999 ) );

                // Position of case according to gametype
                startPoint = basePosition + ( 0, 0, 40 );

                fieldOrderTrigger = spawn("trigger_radius", basePosition, 0, 20, 50 );

	        fieldOrder = spawn("script_model", startPoint );
	        fieldOrder setModel( game[level.gameType]["fieldOrderModel"] );

                fieldOrder thread showObjFieldOrder( basePosition, fieldOrderTrigger );

                // Rotate Model
                fieldOrder thread rotate();

                // Wait for another player to pickup the briefcase
                fieldOrder thread removeTriggerOnPickup( fieldOrderTrigger, fieldOrder );

                if( level.scr_field_order_timer_reset > 0 )
                        fieldOrder thread timerReset( fieldOrder, fieldOrderTrigger );


        }

        // Self has orders and loses them
        if( isDefined( self.hasFieldOrders ) && self.hasFieldOrders == true ) {

                self.hasFieldOrders = false;

                // Place spawnpoint on the ground based on player box size 
                basePosition = playerPhysicsTrace( self.origin, self.origin + ( 0, 0, -99999 ) );

                // Position of case according to gametype
                startPoint = basePosition + ( 0, 0, 40 );
                
                fieldOrderTrigger = spawn("trigger_radius", basePosition, 0, 20, 50 );

	        fieldOrder = spawn("script_model", startPoint );
	        fieldOrder setModel( game[level.gameType]["fieldOrderModel"] );

                fieldOrder thread showObjFieldOrder( basePosition, fieldOrderTrigger );

                // Rotate Model
                fieldOrder thread rotate();

                // Wait for another player to pickup the briefcase
                fieldOrder thread removeTriggerOnPickup( fieldOrderTrigger, fieldOrder );

                // Field Order Failed
	        notifyData = spawnStruct();
	        notifyData.titleText = "Field Orders Failed";
                notifyData.notifyText = "Better luck next time!";
	        notifyData.iconName = "blue_briefcase";
                notifyData.sound = "mp_war_objective_taken";
                notifyData.glowColor = ( 0, 0.9, 1 ); // light blue
	        notifyData.duration = 5.0;

                self thread maps\mp\gametypes\_hud_message::notifyMessage( notifyData );

                if( level.scr_field_order_timer_reset > 0 )
                        fieldOrder thread timerReset( fieldOrder, fieldOrderTrigger );


        } 
	
        if( isDefined( attacker.hasFieldOrders ) && attacker.hasFieldOrders == true && attacker != self ) {
                if( isDefined( attacker.fieldOrdersComplete ) && attacker.fieldOrdersComplete == false ) {  

                        stance = attacker GetStance();
                        
                        // Check crouched kills
                        if( attacker.orderNumber == 0 ) {
                                if( stance == "crouch" ) {
                                        attacker.crouchKill++;
                                        //attacker iprintln( attacker.crouchKill );
                                
                                        if( isExplosive( sWeapon ) || isHardpoint( sWeapon ) ) {
                                                attacker.crouchKill--;
                                                //attacker iprintln( attacker.crouchKill );     
                                        }
                                }

                                if( attacker.crouchKill == level.scr_field_order_0 ) {
                                                attacker.fieldOrdersComplete = true;
                                                attacker.points = level.scr_field_order_0_points;
                                                attacker.crouchKill = 0;
                                }           
                        }

                        // Check prone kills
                        if( attacker.orderNumber == 1 ) {
                                if( stance == "prone" ) {
                                        attacker.proneKill++;
                                        //attacker iprintln( attacker.proneKill );

                                        if( isExplosive( sWeapon ) || isHardpoint( sWeapon ) ) {
                                                attacker.proneKill--;
                                                //attacker iprintln( attacker.proneKill );
                                        }
                                }

                                if( attacker.proneKill == level.scr_field_order_1 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_1_points;
                                        attacker.proneKill = 0;
                                }
                        }

                        // Check headshot kills
                        if( attacker.orderNumber == 2 ) {
                                if( isHeadShot( sWeapon, sHitLoc, sMeansOfDeath ) ) {
                                        attacker.headshotKill++;
                                        //attacker iprintln( attacker.headshotKill );
                                
                                        if( isHardpoint( sWeapon ) ) {
                                                attacker.headshotKill--;
                                                //attacker iprintln( attacker.headshotKill );
                                        }
                                }

                                if( attacker.headshotKill == level.scr_field_order_2 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_2_points;
                                        attacker.headshotKill = 0;
                                }
                        }

                        // Check Melee kills
                        if( attacker.orderNumber == 3 ) {
                                if( sMeansOfDeath == "MOD_MELEE" ) { 
                                        attacker.meleeKill++;
                                        //attacker iprintln( attacker.meleeKill );
                                }

                                if( attacker.meleeKill == level.scr_field_order_3 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_3_points;
                                        attacker.meleeKill = 0;
                                }
                        }

                        // Check jumping kills
                        if( attacker.orderNumber == 4 ) {
                                if( !attacker isOnGround() ) {
                                        attacker.jumpKill++;
                                        //attacker iprintln( attacker.jumpKill );

                                        if( isExplosive( sWeapon ) || isHardpoint( sWeapon ) ) {
                                                attacker.jumpKill--;
                                                //attacker iprintln( attacker.jumpKill );
                                        }
                                }

                                if( attacker.jumpKill == level.scr_field_order_4 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_4_points;
                                        attacker.jumpKill = 0;
                                }
                        }

                        // Check behind kills
                        if( attacker.orderNumber == 5 ) {

                                self.deathAngles = self getPlayerAngles();
                                attacker.deathAngles = attacker getPlayerAngles();

		                vAngles = self.deathAngles[1];
		                pAngles = attacker.deathAngles[1];
		                angleDiff = AngleClamp180( vAngles - pAngles );

		                if ( abs( angleDiff ) < 30 ) {
                                        attacker.behindKill++;
                                        //attacker iprintln( attacker.behindKill );
                                        
                                        if( isExplosive( sWeapon ) || isHardpoint( sWeapon ) ) {
                                                attacker.behindKill--;
                                                //attacker iprintln( attacker.behindKill );
                                        }
                                }

                                if( attacker.behindKill == level.scr_field_order_5 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_5_points;
                                        attacker.behindKill = 0;
                                }
                        }

                        // Check Sniper kills
                        if( attacker.orderNumber == 6 ) {
                                if( maps\mp\gametypes\_weapons::isSniper( sWeapon ) && sMeansofDeath == "MOD_RIFLE_BULLET" ) { 
                                        attacker.sniperKill++;
                                        //attacker iprintln( attacker.sniperKill );
                                }

                                if( attacker.sniperKill == level.scr_field_order_6 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_6_points;
                                        attacker.sniperKill = 0;
                                }
                        }

                        // check pistol kills
                        if( attacker.orderNumber == 7 ) {
                                if( maps\mp\gametypes\_weapons::isPistol( sWeapon ) && sMeansofDeath == "MOD_PISTOL_BULLET" ) { 
                                        attacker.pistolKill++;
                                        //attacker iprintln( attacker.pistolKill );
                                }

                                if( attacker.pistolKill == level.scr_field_order_7 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_7_points;
                                        attacker.pistolKill = 0;
                                }
                        }

                        // Check explosive kills
                        if( attacker.orderNumber == 8 ) {
                                if( isExplosive( sWeapon ) || isProjectile( sWeapon ) ) {
                                        attacker.explosiveKill++;
                                        //attacker iprintln( attacker.explosiveKill );
                                }

                                if( attacker.explosiveKill == level.scr_field_order_8 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_8_points;
                                        attacker.explosiveKill = 0;
                                }
                        }


                        // Check Hardpoint kills
                        if( attacker.orderNumber == 9 ) {
                                if( isHardpoint( sWeapon ) ) {
                                        attacker.hardpointKill++;
                                        //attacker iprintln( attacker.hardpointKill );
                                }

                                if( attacker.hardpointKill == level.scr_field_order_9 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_9_points;
                                        attacker.hardpointKill = 0;
                                }
                        }

                        // Check Picked up weapon
                        if( attacker.orderNumber == 10 ) {
                                if( isDefined( attacker.tookWeaponFrom[ sWeapon ] ) ) {
                                        attacker.pickedWeaponKill++;
                                        //attacker iprintln( attacker.pickedWeaponKill );
                                      
                                        if( sMeansOfDeath == "MOD_MELEE" ) {
                                                attacker.pickedWeaponKill--; 
                                        }      
                                }

                                if( attacker.pickedWeaponKill == level.scr_field_order_10 ) {
                                        attacker.fieldOrdersComplete = true;
                                        attacker.points = level.scr_field_order_10_points;
                                        attacker.pickedWeaponKill = 0;
                                }
                        }

                        // Check humiliation
                        if( attacker.orderNumber == 11 ) { 

                                // Hardpoint kills cause error for distance on attacker origin
                                if( isHardpoint( sWeapon ) ) {
                                        return;
                                }

                                attacker.hasHumiliated = false;

                                if( isDefined( attacker.hasHumiliated ) && attacker.hasHumiliated == false ) {

                                        thisBody = self.body;

                                        // Wait until the body is not moving anymore
                                        wait ( 0.5 );
	                                thisBody maps\mp\gametypes\_weapons::waitTillNotMoving();
 
                                        attackerDistance = distance( thisBody.origin, attacker.origin );

                                        //iprintln( attackerDistance );

                                        while( isDefined( attackerDistance ) && attackerDistance > 30 ) {
                                                attackerDistance = distance( thisBody.origin, attacker.origin );
                                                wait( 0.05 );

                                                if( isDefined( attacker.hasHumiliated ) && attacker.hasHumiliated == true )
                                                        break;

                                                //iprintln( "waiting" );
                                        }

                                        while( isDefined( attackerDistance ) && attackerDistance < 30 ) {

                                                attackerStance1 = attacker getStance();
                                                //attacker iprintln( attackerStance1 );
                                                wait ( 0.6 );
                  
                                                attackerStance2 = attacker getStance();
                                                //attacker iprintln( attackerStance2 );
                                                wait ( 0.6 );
                                        
                                                attackerStance3 = attacker getStance();
                                                //attacker iprintln( attackerStance3 );
                                                wait ( 0.6 );
                                        
                                                if( attackerStance1 != attackerStance2 && attackerStance1 == attackerStance3 ) {
                                                        attacker.fieldOrdersComplete = true;
                                                        attacker.points = level.scr_field_order_11_points;
                                                        attacker.hasHumiliated = true;
                                                        break;

                                                } 

                                                attackerDistance = distance( thisBody.origin, attacker.origin );  
                                                //iprintln( "on body" );
                                      
                                        }  
                                }    
                        }

                        waittillframeend;

                }

                //Orders complete
                if( isDefined( attacker.fieldOrdersComplete ) && attacker.fieldOrdersComplete == true ) {

                        if( isAlive( attacker ) ) {

                                attacker.fieldOrdersComplete = false;
                                attacker.orderNumber = -1;

                                if( isDefined( attacker.caseIcon ) )
                                        attacker.caseIcon.alpha = 0;

                                if( level.scr_field_orders == 1 )
                                        attacker thread completeOrdersPerks();

                                if( level.scr_field_orders == 2 )
                                        attacker thread completeOrdersPoints();

                                if( level.scr_field_orders == 3 )
                                        attacker thread completeOrdersHardPoints();

                                if( level.scr_field_orders == 4 ) {

                                        choice = randomIntRange( 1, 3 );

                                        if( choice == 1 ) 
                                                attacker thread completeOrdersPerks(); 
                                        if( choice == 2 )
                                                attacker thread completeOrdersHardPoints();
                                } 

                                if( level.scr_field_orders == 5 ) {

                                        choice = randomIntRange( 1, 4 );

                                        if( choice == 1 ) 
                                                attacker thread completeOrdersPerks(); 
                                        if( choice == 2 )  
                                                attacker thread completeOrdersPoints();
                                        if( choice == 3 )
                                                attacker thread completeOrdersHardPoints();
                                }     
                        
                                // Stop order reminder
                                attacker notify( "orders_completed" );

                                // Wait to process current kills........wait time is IMPORTANT!!!!!!!
                                wait( 0.06 );

                                // Clear Dvars for next Field Order
                                attacker.hasFieldOrders = false;
                                level.fieldOrdersActive = false;
                                attacker.statusicon = "";

                        } 

                }    
          
        }

        //Debug
        //iprintln( "Check Complete" );

        self notify( "check_complete" );

}

completeOrdersHardPoints()
{

	// Wait some time to make sure the previous hardpoint is given	
        wait( 0.5 );

        // Wait till existing notify is done
        while( isDefined( self.doingNotify ) && self.doingNotify == true )
                wait( 0.05 );
        
	// Remove any existing hardpoint so we can give new one
	if ( isDefined( self.pers["hardPointItem"] ) ) {
		       self.pers["hardPointItem"] = undefined;
                       if( level.scr_field_order_kill_streak_reset == 1 )
                               self.cur_kill_streak = 0; 
	}

        // Random or picked choice
        if( level.scr_field_order_hardpoint_type == 0 ) {
                choice = randomIntRange( 1, 4 );

        } else {

                choice = level.scr_field_order_hardpoint_type;

        }


        if( choice == 1 ) {

                self maps\mp\gametypes\_hardpoints::giveHardpointItem( "radar_mp" );
                self.pers["hardPointItem"] = "radar_mp";
                self.perkPick = "a UAV Hardpoint";
        }

        if( choice == 2 ) {
                if ( level.teambased ) {
                        level.allies_last_airstrike = -999;
                        level.axis_last_airstrike = -999;

                } else {

                        self.pers["last_airstrike"] = -999;
                }

                self maps\mp\gametypes\_hardpoints::giveHardpointItem( "airstrike_mp" );
                self.pers["hardPointItem"] = "airstrike_mp";
                self.perkPick = "an Airstrike Hardpoint";
         }

        if( choice == 3 ) {
                if ( level.teambased ) {
                        level.allies_last_heli = -999;
                        level.axis_last_heli = -999;

                } else {

                        self.pers["last_heli"] = -999;
                }

                self maps\mp\gametypes\_hardpoints::giveHardpointItem( "helicopter_mp" );
                self.pers["hardPointItem"] = "helicopter_mp";
                self.perkPick = "a Helicopter Hardpoint";

        }


	hardpointType = self.pers["hardPointItem"];

        // Notify Hardpoint
	notifyData = spawnStruct();
	notifyData.titleText = "Field Orders Completed";
        notifyData.notifyText = ( "You received " + self.perkPick );
        //notifyData.iconName = "blue_briefcase";
        notifyData.leaderSound = hardpointType;
        notifyData.sound = level.hardpointInforms[hardpointType];
        notifyData.glowColor = ( 0, 0.9, 1 ); // light blue
	notifyData.duration = 4.5;

        self thread maps\mp\gametypes\_hud_message::notifyMessage( notifyData );

}
                
completeOrdersPoints()
{

	notifyData = spawnStruct();
	notifyData.titleText = "Field Orders Completed";

        if( self.points != 0 ) {

                if( level.teamBased ) {
                        if( level.overrideTeamScore == true ) {
                                notifyData.notifyText = ( "+" + self.points + " Player Points" );
 
                        } else {

                                notifyData.notifyText = ( "+" + self.points + " Points" );
                        } 

                } else {

                        notifyData.notifyText = ( "+" + self.points + " Player Points" );
                }

        }

	//notifyData.iconName = "blue_briefcase";
        notifyData.sound = "mp_war_objective_lost";
        notifyData.glowColor = ( 0, 0.9, 1 ); // light blue
	notifyData.duration = 4.5;

        self thread maps\mp\gametypes\_hud_message::notifyMessage( notifyData );

        // Give score 
        if( level.teamBased ) {
                if( level.overrideTeamScore == true ) {
                        self thread givePlayerScore( "challenge", self.points );

                } else {

                        self thread givePlayerScore( "challenge", self.points );
                        [[level._setTeamScore]]( self.pers["team"], [[level._getTeamScore]]( self.pers["team"] ) + self.points );
                }

        } else {   

                self thread givePlayerScore( "challenge", self.points );

        }

        // Clear Points Dvar
        self.points = 0;

}

completeOrdersPerks()
{

        if( level.scr_field_order_perks == 0 ) {
                self.pickPerk = randomIntRange( 1, 13 );

        } else {

                self.pickPerk = level.scr_field_order_perks;

        }

        if( isAlive( self ) )
        {   
                switch ( self.pickPerk )
                {  
                        // Full Ammo
                        case 1: 
 	                     
                                      weaponslist = self getweaponslist();
	                              for( i = 0; i < weaponslist.size; i++ )
	                              {
		                              weapon = weaponslist[i];
                                              self giveMaxAmmo( weapon );
                                           
                                      }
                                      self.perkPick = "Full Ammo";

                                      break;

                        // Extra Health
                        case 2:
                                      // Set health
                                      self.maxhealth = getDvarInt( "scr_player_maxhealth" ) * level.scr_field_order_extra_health;
	                              self.health = getDvarInt( "scr_player_maxhealth" ) * level.scr_field_order_extra_health;
                                      self.perkPick = "Extra Health";

                                      // Debug
                                      // self iprintln( self.health );
                              
                                      break;

                        // Special Weapon
                        case 3:
                                      // If player already has Special weapon, just give it max ammo
                                      weaponsList = self getWeaponsList();
                                      for( i = 0; i < weaponsList.size; i++ )	{
                                              //iprintln( weaponsList[i] );
	                                      if ( weaponsList[i] == level.scr_field_order_special_weapon ) {
                                                      self.hasSpecialWeapon = true;
                                                      self switchToWeapon( weaponsList[i] );
		                                      self giveMaxAmmo( weaponsList[i] );
                                                      self.perkPick = "Full Special Weapon Ammo";
                                                      break;
                                              }

	                              } 

                                      // Break if player already has special weapon
                                      if ( isDefined( self.hasSpecialWeapon ) && self.hasSpecialWeapon == true ) {
                                              break;
                                      }
                                      

                                      // Give Special Weapon
                                      specialWeapon = "";

                                      // Disable Weapon
                                      self thread maps\mp\gametypes\_gameobjects::_disableWeapon();

	                              // Force Special Weapon
	                              if ( level.scr_field_order_special_weapon != "" ) {
		                              specialWeapon = level.scr_field_order_special_weapon;
                                      }

                                      // Give Weapon
                                      self giveWeapon( specialWeapon );

                                      // Set Ammo
                                      self giveMaxAmmo( specialWeapon );

                                      // Get ready to spawn weapon
                                      self setSpawnWeapon( specialWeapon );
	                              self switchToWeapon( specialWeapon );

	                              // Enable the Special weapon
	                              self thread maps\mp\gametypes\_gameobjects::_enableWeapon();

                                      self.perkPick = "a Special Weapon";

                                      break;

                        // Faster Move Speed
                        case 4:
                                      // Give more speed if you already have it
                                      if( isDefined( self.hasFasterSpeed ) && self.hasFasterSpeed == true ) { 
                                              self thread openwarfare\_speedcontrol::setBaseSpeed( level.scr_field_order_move_speed + 0.05 );
                                      } else {
                                              self thread openwarfare\_speedcontrol::setBaseSpeed( level.scr_field_order_move_speed );
                                      }

                                      self.hasFasterSpeed = true;
                                      self.perkPick = "Faster Move Speed";

			              break;

                        // Extra Grenades
                        case 5:

                                      weaponslist = self getweaponslist();
	                              for( i = 0; i < weaponslist.size; i++ )
	                              {
		                              weapon = weaponslist[i];
                                              if( weapon == "frag_grenade_mp" ) 
                                                      self setWeaponAmmoClip( "frag_grenade_mp", 3 );
                                              
                                      }

                                      self.perkPick = "Full Grenade Ammo";

                                      break;

                        // See all Enemies
                        case 6:

                                      self setClientDvar( "g_compassshowenemies", "1" );

                                      self thread showEnemyCompassTimer();

                                      self.perkPick = "a Compass Showing Enemy Players";

                                      break;

                        // FlashBang Armor
                        case 7: 

                                      self.flashProtected = true;
                                     
                                      self.perkPick = "FlashBang Armor";
 	                     
                                      break;

                        // Concussion Armor
                        case 8: 

                                      self.concussionProtected = true;

                                      self.perkPick = "Stun Grenade Armor";

                                      break;

                        // Claymore Armor
                        case 9: 

                                      self.claymoreProtected = true;

                                      self.perkPick = "Claymore Armor";

                                      break;

                        // C4 Armor
                        case 10: 

                                      self.c4Protected = true;

                                      self.perkPick = "C4 Armor";

                                      break;

                        // Frag Armor
                        case 11: 

                                      self.fragProtected = true;

                                      self.perkPick = "Frag Grenade Armor";

                                      break;

                        // Hardpoint Armor
                        case 12: 

                                      self.hardpointProtected = true;

                                      self.perkPick = "Hardpoint Armor";

                                      break;


                        default :     
                                      break;
                }

	        notifyData = spawnStruct();
	        notifyData.titleText = "Field Orders Completed";
                notifyData.notifyText = ( "You received " + self.perkPick );
	        //notifyData.iconName = "blue_briefcase";
                notifyData.sound = "mp_war_objective_lost";
                notifyData.glowColor = ( 0, 0.9, 1 ); // light blue
	        notifyData.duration = 4.5;

                self thread maps\mp\gametypes\_hud_message::notifyMessage( notifyData );

        }


}

timerReset( fieldOrder, fieldOrderTrigger )
{
        level endon( "game_ended" );
        level endon( "intermission" );
        fieldOrder endon( "picked_up" );

        xWait( level.scr_field_order_timer_reset );

        // Explosion FX
        if( level.scr_field_order_explosion_fx == 1 ) {
                playFx( game[level.gameType]["blue_fx"], fieldOrder.origin );
        }

        level.fieldOrdersActive = false;

        // Notify of spoofed pickup
        fieldOrderTrigger notify( "timer_reset" );

        // Shut off 2D and 3D icons
        fieldOrderTrigger notify( "trigger" );

        wait( 0.08 );

        // Delete Trigger and Model
        fieldOrderTrigger delete();
	fieldOrder delete();

        // Notify trigger and model picked up
        fieldOrder notify( "picked_up" );
}

showEnemyCompassTimer()
{
        self endon( "death" ); 
	self endon( "disconnect" );
	level endon( "game_ended" );

        if( level.scr_field_order_uav_time == 0 )
                return;

        wait( level.scr_field_order_uav_time );

        if( level.scr_game_forceuav == 0 ) 
                self setClientDvar( "g_compassshowenemies", "0" );

}

givePlayerScore( event, score )
{
	self maps\mp\gametypes\_rank::giveRankXP( event, score );
		
	self.pers["score"] += score;
	self maps\mp\gametypes\_persistence::statAdd( "score", ( self.pers["score"] - score ) );
	self.score = self.pers["score"];
	self notify ( "update_playerscore_hud" );
}

rotate()

{
	self endon( "picked_up" );


	while( true )

	{

           self movez( -20, 1.5, 0.3, 0.3 );

	   self rotateyaw( 360, 1.5, 0, 0 );

	   wait( 1.5 );

	   self movez( 20, 1.5, 0.3, 0.3 );

	   self rotateyaw( 360 ,1.5, 0, 0 );

	   wait( 1.5 );

	}

}
                
AngleClamp180( angle )
{
	angleFrac = angle / 360.0;
	angle = ( angleFrac - floor( angleFrac ) ) * 360.0;
	if( angle > 180.0 )
		return angle - 360.0;
	return angle;
}

isExplosive( weapon )
{
	if ( isSubStr( weapon, "frag_" ) )
		return true;
	if ( isSubStr( weapon, "claymore_" ) )
		return true;
	if ( isSubStr( weapon, "c4_" ) )
		return true;

	return false;
}

isProjectile( weapon )
{
	if ( isSubStr( weapon, "rpg_" ) )
		return true;
	if ( isSubStr( weapon, "gl_" ) )
		return true;
	if ( isSubStr( weapon, "_gl_" ) )
		return true;

	return false;
}

isHardpoint( weapon )
{
	if ( isSubStr( weapon, "artillery_" ) )
		return true;
	if ( isSubStr( weapon, "cobra_" ) )
		return true;
	if ( isSubStr( weapon, "hind_" ) )
		return true;
	if ( isSubStr( weapon, "helicopter_" ) )
		return true;

	return false;
}

showReminder( text )
{
	self endon( "orders_completed" );
        self endon( "death" ); 
	self endon( "disconnect" );
	level endon( "game_ended" );

        while( 1 )
        {
                wait( level.scr_field_order_reminder_time );
                self iprintln( "^5Field Orders: " + text );
        }

}

isHeadShot( sWeapon, sHitLoc, sMeansOfDeath )
{
	return (sHitLoc == "head" || sHitLoc == "helmet") && sMeansOfDeath != "MOD_MELEE" && sMeansOfDeath != "MOD_IMPACT" && !isMG( sWeapon );
}

showObjFieldOrder( basePosition, fieldOrderTrigger )
{
        self endon( "picked_up" );
        level endon( "game_ended" );

        // Time before Icons show Field order
        if( level.scr_field_order_timer > 0 ) 
                Xwait( level.scr_field_order_timer );
        

	// Get ID to use for Field order
        if ( level.scr_hud_show_2dicons == 1 ) {
	        objCompassFieldOrder = maps\mp\gametypes\_gameobjects::getNextObjID();
	        if ( objCompassFieldOrder != -1 ) {
		        objective_add( objCompassFieldOrder, "active", basePosition + ( 0, 0, 105 ) );
		        objective_icon( objCompassFieldOrder, "compass_field_order" );
            
	        }

	        // Start the thread to delete objCompassFieldOrder once picked up
	        self thread deleteobjCompassFieldOrder( fieldOrderTrigger, objCompassFieldOrder );
        }

        // Create pickup icon for everyone
	if ( level.scr_hud_show_3dicons == 1 ) {
                objWorldFieldOrder = newHudElem();
                origin = basePosition + ( 0, 0, 105 );
                objWorldFieldOrder.x = origin[0];
                objWorldFieldOrder.y = origin[1];
                objWorldFieldOrder.z = origin[2];
                objWorldFieldOrder.baseAlpha = 1.0;
                objWorldFieldOrder.isFlashing = false;
                objWorldFieldOrder.isShown = true;
                objWorldFieldOrder setShader( "waypoint_field_order", level.objPointSize, level.objPointSize );
                objWorldFieldOrder setWayPoint( true, "waypoint_field_order" );
                objWorldFieldOrder thread maps\mp\gametypes\_objpoints::startFlashing();

	        // Start the thread to delete objWorldFieldOrder once picked up
	        self thread deleteobjWorldFieldOrder( fieldOrderTrigger, objWorldFieldOrder );

        }

}

deleteobjWorldFieldOrder( fieldOrderTrigger, objWorldFieldOrder )
{

	fieldOrderTrigger waittill( "trigger", player );

	// Stop flashing Kill icon
	objWorldFieldOrder notify("stop_flashing_thread");
	objWorldFieldOrder thread maps\mp\gametypes\_objpoints::stopFlashing();

	// Wait some time to make sure the main loop ends	
	wait( 0.25 );

        if( isDefined( objWorldFieldOrder ) ) {
                objWorldFieldOrder destroy();
        }
	
}

deleteobjCompassFieldOrder( fieldOrderTrigger, objID  )
{

	fieldOrderTrigger waittill( "trigger", player );

	// Wait some time to make sure the main loop ends	
	wait( 0.25 );
	
	// Delete the objective
	if ( objID != -1 ) {
		objective_delete( objID );
		maps\mp\gametypes\_gameobjects::resetObjID( objID );
	}
	
}